--- zaptel-1.2.13/wctdm.c	2007-01-31 11:06:34.000000000 -0300
+++ zaptel-1.2.13mod2/wctdm.c	2007-03-02 11:18:52.000000000 -0300
@@ -323,6 +323,8 @@
 		        int lastpol;
 		        int polarity;
 		        int polaritydebounce;
+			int readcid;
+			unsigned int cidtimer;
 		} fxo;
 		struct {
 			int oldrxhook;
@@ -378,6 +380,7 @@
 static char *opermode = "FCC";
 static int fxshonormode = 0;
 static int alawoverride = 0;
+static int dtmf = 0;
 
 static int wctdm_init_proslic(struct wctdm *wc, int card, int fast , int manual, int sane);
 
@@ -459,6 +462,7 @@
 			if (!wc->mod[card].fxo.offhook)
 				zt_hooksig(&wc->chans[card], ZT_RXSIG_RING);
 			wc->mod[card].fxo.ring = 1;
+			wc->mod[card].fxo.readcid = 1;
 		}
 		if (wc->mod[card].fxo.ring && !wc->mod[card].fxo.pegcount) {
 			/* No more ring */
@@ -466,10 +470,31 @@
 				printk("NO RING on %d/%d!\n", wc->span.spanno, card + 1);
 			zt_hooksig(&wc->chans[card], ZT_RXSIG_OFFHOOK);
 			wc->mod[card].fxo.ring = 0;
+			wc->mod[card].fxo.cidtimer = wc->intcount;
+			wc->mod[card].fxo.readcid = 0;
 		}
 	}
 }
 #endif
+static inline void wctdm_dtmfcheck_fakepolarity(struct wctdm *wc, int card, int x)
+{
+	int sample;
+	if (dtmf && (wc->cardflag & (1 << card)) && wc->modtype[card] == MOD_TYPE_FXO && !wc->mod[card].fxo.offhook ) {
+		if(!wc->mod[card].fxo.readcid && !wc->mod[card].fxo.wasringing  &&
+		wc->intcount > wc->mod[card].fxo.cidtimer + 400 ) {
+			sample = ZT_XLAW(wc->chans[card].readchunk[x], (&(wc->chans[card])));
+			if (sample > 16000 || sample < -16000) {
+				wc->mod[card].fxo.readcid = 1;
+				wc->mod[card].fxo.cidtimer = wc->intcount;
+				if (debug) printk("DTMF CLIP on %i\n",card+1);
+				zt_qevent_lock(&wc->chans[card], ZT_EVENT_POLARITY);
+			}
+		} else if(wc->intcount > wc->mod[card].fxo.cidtimer + 2000) {
+			wc->mod[card].fxo.cidtimer = wc->intcount;
+			wc->mod[card].fxo.readcid = 0;
+		}
+	}
+}
 static inline void wctdm_receiveprep(struct wctdm *wc, unsigned char ints)
 {
 	volatile unsigned int *readchunk;
@@ -500,6 +525,10 @@
 		if (wc->cardflag & (1 << 0))
 			wc->chans[0].readchunk[x] = (readchunk[x]) & 0xff;
 #endif
+		wctdm_dtmfcheck_fakepolarity(wc,0,x);
+		wctdm_dtmfcheck_fakepolarity(wc,1,x);
+		wctdm_dtmfcheck_fakepolarity(wc,2,x);
+		wctdm_dtmfcheck_fakepolarity(wc,3,x);
 	}
 #ifdef AUDIO_RINGCHECK
 	for (x=0;x<wc->cards;x++)
@@ -871,6 +900,8 @@
 			if (wc->mod[card].fxo.ringdebounce <= 0) {
 				if (wc->mod[card].fxo.wasringing) {
 					wc->mod[card].fxo.wasringing = 0;
+					wc->mod[card].fxo.readcid = 0;
+					wc->mod[card].fxo.cidtimer = wc->intcount;
 					zt_hooksig(&wc->chans[card], ZT_RXSIG_OFFHOOK);
 					if (debug)
 						printk("NO RING on %d/%d!\n", wc->span.spanno, card + 1);
@@ -2407,6 +2438,7 @@
 module_param(battdebounce, int, 0600);
 module_param(battthresh, int, 0600);
 module_param(alawoverride, int, 0600);
+module_param(dtmf, int, 0600);
 #else
 MODULE_PARM(debug, "i");
 MODULE_PARM(loopcurrent, "i");
